#include <stdlib.h>
#include <stdint.h>

int Timer_Install(int id, void (*handler)(void), int delay);
int Timer_Start(int id);
int Timer_Stop(int id);
int Timer_Deinstall(int id);
int Keyboard_PutKeycode(int row, int column, int keycode);
//-------------------------------------------------------------- Return to menu

// Note: Cet add-in n'a pas de runtime, menutimer n'est pas initialisé auto-
// matiquement; l'initialisation est répétée dans main()
static volatile int menutimer=0;
void clear_menu_timer(){
  if (menutimer > 0) {
    // menu row 9 col 4
    Timer_Stop(menutimer);
    Timer_Deinstall(menutimer);
    menutimer=0;
  }
}

void send_menu_key(){
  if (menutimer > 0) {
    clear_menu_timer();
//    OS_InnerWait_ms(50);
    // menu row 9 col 4
    // Keyboard_PutKeycode(4,9,KEY_CTRL_MENU);
    Keyboard_PutKeycode(4,9,0);
  }
}

void set_menu_timer(){
  if (menutimer) return;
  menutimer = Timer_Install(0,send_menu_key, 200);
  if (menutimer > 0) {
    Timer_Start(menutimer);
  }
}

//----------------------------------------------------------------- Memory test

static const char *numbers[] = {
	"__0", "__1", "__2", "__3", "__4", "__5", "__6", "__7", "__8", "__9",
	"__10", "__11", "__12", "__13", "__14", "__15", "__16", "__17" };
static const char *status[] = { "__Does not match", "__Matches" };

void Bdisp_AllClr_VRAM();
void Bdisp_PutDisp_DD();
void PrintXY(int x, int y, char const *msg, int mode, int color);
int GetKey(int *key);

void fill_memory(uint8_t *buffer, size_t size)
{
	srand(0xc0ffee);
	for(size_t i = 0; i < size; i++) {
		buffer[i] = rand() & 0xff;
	}
}

int check_memory(uint8_t *buffer, size_t size)
{
	srand(0xc0ffee);
	for(size_t i = 0; i < size; i++) {
		if(buffer[i] != (rand() & 0xff))
			return 0;
	}
	return 1;
}

#define SIZE_URAM 420000
uint8_t buf_uram[SIZE_URAM];

#define SIZE_XRAM 2048
static uint8_t *buf_xram = (void *)0xe5007000;

#define SIZE_YRAM 2048
static uint8_t *buf_yram = (void *)0xe5017000;

#define SIZE_ILRAM 2048
static uint8_t *buf_ilram = (void *)0xe5200000;

int main(void)
{
//	fill_memory(buf_uram, SIZE_URAM);
	fill_memory(buf_xram, SIZE_XRAM);
	fill_memory(buf_yram, SIZE_YRAM);
	fill_memory(buf_ilram, SIZE_ILRAM);
	int count=0, key;

	menutimer = 0;

	while(count <= 17) {
		Bdisp_AllClr_VRAM();
		PrintXY(1, 1, numbers[count], 0, 0);
		PrintXY(4, 1, numbers[menutimer], 0, 0);

//		PrintXY(1, 2, "__URAM", 0, 0);
//		PrintXY(7, 2, status[check_memory(buf_uram, SIZE_URAM)], 0, 0);

		PrintXY(1, 3, "__XRAM", 0, 0);
		PrintXY(7, 3, status[check_memory(buf_xram, SIZE_XRAM)], 0, 0);

		PrintXY(1, 4, "__YRAM", 0, 0);
		PrintXY(7, 4, status[check_memory(buf_yram, SIZE_YRAM)], 0, 0);

		PrintXY(1, 5, "__ILRAM", 0, 0);
		PrintXY(7, 5, status[check_memory(buf_ilram, SIZE_ILRAM)], 0, 0);

		Bdisp_PutDisp_DD();
		GetKey(&key);
		count++;

		if(key == '7') {
			set_menu_timer();
			GetKey(&key);
		}
	}

	return 1;
}

__attribute__((section(".text.entry")))
int start(void)
{
	return main();
}
